#include <bits/stdc++.h>
using namespace std;
long long a[80000], b[80000];
long long gcd(long long a, long long b)
{
    if(b == 0) return a;
    return gcd(b, a%b);
}
int main()
{
    ios_base::sync_with_stdio(false);
    long long t, n, m, i, nzd = 0, r, ans = 1;
    cin >> t;
    while(t--)
    {

        cin >> n >> m;
        for(i = 0; i < n; i++) cin >> a[i];
        for(i = 0; i < m; i++) cin >> b[i];
        sort(a, a + n);
        for(i = 1; i < n; i++) nzd = gcd(nzd, a[i] - a[i - 1]);
        r = a[0] % nzd;
        for(i = 0; i < m; i++) if(b[i] % nzd == r) ans = 0;
        cout << ans << endl;
        nzd = 0;
        ans = 1;
    }
    return 0;
}